

	HIWORD MACRO ParamFen,register:REQ
		mov register,ParamFen
		shr register,16
	ENDM
	LOWORD MACRO ParamFen,register:REQ
		mov register,ParamFen
		and register,0FFFFh
	ENDM
	
	ZEROLOCALES MACRO dernierelocale
		mov eax, esp
		mov esp, ebp	; base page of calling procedure
		@@:
		push 0
		cmp esp, eax
		ja @B	
	ENDM	
	
STDERR MACRO
	call  __iob_func
	add eax,2 * sizeof (_iobuf) ; _iobuf structure #define stderr (&__iob_func()[2])
	mov sortiestd,eax
	EXITM <sortiestd>
ENDM
STDIN MACRO
	call  __iob_func
	add eax,0 * sizeof (_iobuf) ; _iobuf structure #define stdin  (&__iob_func()[0])
	mov sortiestd,eax
	EXITM <sortiestd>

ENDM
STDOUT MACRO
	call  __iob_func
	add eax,1 * sizeof (_iobuf) ; _iobuf structure #define stdout (&__iob_func()[1])
	mov sortiestd,eax
	EXITM <sortiestd>

ENDM
	
	
F MACRO retour:REQ,arg1:VARARG
	invoke arg1
	mov retour,eax
	EXITM <retour>	
ENDM

PuPo MACRO M1, M2
	push M2
	pop  M1
ENDM

;----------------- SYNTAX  Pointer on structure,Offset,...
;the array of pointer allow to pass the limit of three registers usable for the call
;arg1 dword pointer,arg2 offset in structure,offset of an array of pointer
PADR MACRO pointer_name:REQ,interne_struct:REQ,arg3:REQ
	result INSTR <pointer_name>,<.>
	IF result
		result = result + 1
		indirect SUBSTR <pointer_name>,result  ;TEXTEQU @SubStr (<pointer_name>,result)
		computeoffset CATSTR <DECLARE_>,indirect,<.>,<interne_struct>	
					
	ELSE
		computeoffset CATSTR <DECLARE_>,<pointer_name>,<.>,<interne_struct>
	ENDIF
	;%ECHO computeoffset
	push edx
	mov edx,pointer_name
	lea edx,[edx].computeoffset         
	mov [BUFIDR+arg3],edx
	pop edx
	EXITM <dword ptr [BUFIDR+arg3]>
ENDM


;macro basique pour reutilisation
;peut prendre une valeur dans une structure et retourne edx
;registres modifis ecx edx
PGET MACRO pointer_name:REQ,decale:REQ
	;--------------------------- suprimer () ---------------------
	verif SUBSTR <pointer_name>,1,1
	IFIDN verif,<(>            ;si le premier caractere est "
		newpointer_name SUBSTR <pointer_name>,2
	ELSE
		newpointer_name SUBSTR <pointer_name>,1			
	ENDIF	
	count SIZESTR <decale>
	verif SUBSTR <decale>,count,1
	IFIDN verif,<)>            ;si le premier caractere est "
		redecale SUBSTR <decale>,1,count - 1
	ELSE
		redecale SUBSTR <decale>,1			
	ENDIF	
	 ;-------------- suite ---------------------------------------
	count INSTR newpointer_name,<.>		;get a pointer on a structure
		
	IF count GT 0
		;extract pointer from structure
		;bivalent = offset premiere structure = pointeur deuxieme structure
		;pointer1 = pointeur sur premiere structure
		
		bivalent SUBSTR newpointer_name,count +1
		pointer1 SUBSTR newpointer_name,1,count -1
		;  
		
		dec_srtuct1 CATSTR <DECLARE_>,pointer1  ;extract structure from DECLARE_...
		dec_srtuct2 CATSTR <DECLARE_>,bivalent		
		IF OPATTR dec_srtuct1 EQ 24h			;constant OR structure in data ?
			computeoffset1 CATSTR dec_srtuct1,<.>,bivalent 	
			computeoffset2 CATSTR dec_srtuct2,<.>,redecale 
			mov edx,pointer1
			mov edx,[edx].computeoffset1		;pointeur sur deuxieme structure
		ELSE
			;ECHO structure in data
			computeoffset2 CATSTR dec_srtuct2,<.>,redecale			
			mov edx,newpointer_name	; en data: nom structure <>
		ENDIF
					
	ELSE
		;ECHO PGET sans point
				;STRUCTURE + nom interne
		computeoffset2 CATSTR <DECLARE_>,newpointer_name,<.>,redecale
		mov edx,newpointer_name
		
	ENDIF
	;------------------ edx pointer on structure -----------------
	;%ECHO computeoffset2
	;-------- value dans edx ----------------
	;%ECHO PGET computeoffsetpget = computeoffsetpget					
	count = sizeof computeoffset2
	IF count LE 2
		movzx edx,[edx+computeoffset2]	
	ELSEIF count EQ 4
		mov edx,DWORD PTR [edx+computeoffset2]
	ELSEIF count EQ 8
		mov ecx,DWORD PTR [edx+computeoffset2]
		mov edx,DWORD PTR [edx+computeoffset2+4]
	ELSE
		.ERR <'PGET couldn't solve'>
	ENDIF	
ENDM




ValuePointedBy MACRO pointeur
	mov ecx,pointeur
	mov edx,[ecx]
	EXITM <edx>
ENDM

;macro basique pour reutilisation
;met une valeur dans une structure 
PPUT MACRO pointer_name:REQ,decale:REQ,lowvalue:REQ,hightvalue
	result INSTR <pointer_name>,<.>
	IF result
		;extraire le pointeur de la structure
		;indirect = offset premiere structure = pointeur deuxieme structure
		;pointer1 = pointeur sur premiere structure
		result = result + 1
		bivalent SUBSTR <pointer_name>,result	
		result = result - 2
		pointer1 SUBSTR <pointer_name>,1,result		
		;  
		testeur CATSTR <DECLARE_>,pointer1
		IF OPATTR testeur EQ 24h			;constant OR structure in data ?
			computeoffset1 CATSTR <DECLARE_>,pointer1,<.>,bivalent 	
			computeoffset CATSTR <DECLARE_>,bivalent,<.>,<decale> 		
			mov edx,pointer1
			mov edx,[edx].computeoffset1		;pointeur sur deuxieme structure
		ELSE
			computeoffset CATSTR <DECLARE_>,bivalent,<.>,<decale>		
			mov edx,pointer_name	; en data: nom structure <>
		ENDIF
					
	ELSE
		;STRUCTURE + nom interne
		mov edx,pointer_name
		computeoffset CATSTR <DECLARE_>,<pointer_name>,<.>,<decale>
		
	ENDIF
	;%ECHO PPUT COMPUTEOFFSET = computeoffset						
	
	;tester si lowvalue comporte un point	
	;-------- pointeur sur destination dans edx ----------------
	
	pointvalue INSTR <lowvalue>,<.>	
	IF pointvalue GT 0
		push edx
		valuearg1 SUBSTR <lowvalue>,1,pointvalue - 1
		valuearg2 SUBSTR <lowvalue>,pointvalue + 1
		PGET %valuearg1,%valuearg2
		mov eax,edx		
		pop edx
		;%ECHO pget dans pput computeoffset
		
		mov dword ptr [edx+computeoffset],eax
	ELSE	
		result = sizeof computeoffset	
		IF result EQ 1
			movzx eax,lowvalue 
			mov byte ptr [edx+computeoffset],al
		ELSEIF result EQ 2
			movzx eax,lowvalue 
			mov word ptr [edx+computeoffset],ax			
		ELSEIF result EQ 4
			mov eax,lowvalue
			mov dword ptr [edx+computeoffset],eax
		ELSEIF result EQ 8
			result = 0
			FOR arg, <hightvalue>
				result = result + 1
			ENDM	
			IF result EQ 1
				mov eax,lowvalue
				mov dword ptr [edx+computeoffset+4],eax
				mov ecx,hightvalue	
				mov dword ptr [edx+computeoffset],ecx	
			ELSE
				.ERR <'PUT QWORD need  hightvalue'>
			ENDIF
		ELSE
			.ERR <PPUT couldn't solve>
		ENDIF
	ENDIF		
ENDM
PVALP MACRO pointer_name:REQ,interne_struct:REQ,lowvalue:REQ,hightvalue
		push edx
		push ecx
		push eax
		PPUT pointer_name,interne_struct,lowvalue,hightvalue
		pop eax
		pop ecx
		pop edx
ENDM

PVALG MACRO pointer_name:REQ,interne_struct:REQ,pbufidr:REQ
	push edx
	push ecx
	PGET (pointer_name,interne_struct)
	mov [BUFIDR+pbufidr],edx		
	pop ecx
	pop edx
	EXITM <dword ptr [BUFIDR+pbufidr]>
ENDM




